import { Options } from '../types/Options';
/**
 * Shallow merge (specific or all) properties.
 * If some properties both are arrays, then merge them also.
 */
declare function mergeOptions(rawOptions1: Options | null, rawOptions2: Options | null): {
    color?: boolean | undefined;
    concurrency?: number | undefined;
    configFileName?: string | undefined;
    configFilePath?: string | undefined;
    cwd?: string | undefined;
    deep?: boolean | undefined;
    dep?: string | undefined;
    deprecated?: boolean | undefined;
    doctor?: boolean | undefined;
    doctorInstall?: string | undefined;
    doctorTest?: string | undefined;
    enginesNode?: boolean | undefined;
    errorLevel?: number | undefined;
    filter?: string | RegExp | string[] | import("../types/FilterFunction").FilterFunction | RegExp[] | undefined;
    filterVersion?: string | RegExp | string[] | import("../types/FilterFunction").FilterFunction | RegExp[] | undefined;
    format?: string[] | undefined;
    global?: boolean | undefined;
    groupFunction?: import("../types/GroupFunction").GroupFunction | undefined;
    interactive?: boolean | undefined;
    jsonAll?: boolean | undefined;
    jsonDeps?: boolean | undefined;
    jsonUpgraded?: boolean | undefined;
    loglevel?: string | undefined;
    mergeConfig?: boolean | undefined;
    minimal?: boolean | undefined;
    packageData?: string | undefined;
    packageFile?: string | undefined;
    packageManager?: string | undefined;
    peer?: boolean | undefined;
    pre?: boolean | undefined;
    prefix?: string | undefined;
    registry?: string | undefined;
    reject?: string | RegExp | string[] | import("../types/FilterFunction").FilterFunction | RegExp[] | undefined;
    rejectVersion?: string | RegExp | string[] | import("../types/FilterFunction").FilterFunction | RegExp[] | undefined;
    removeRange?: boolean | undefined;
    retry?: number | undefined;
    silent?: boolean | undefined;
    stdin?: string | undefined;
    target?: "greatest" | "latest" | "minor" | "newest" | "patch" | `@${string}` | import("../types/TargetFunction").TargetFunction | undefined;
    timeout?: number | undefined;
    upgrade?: boolean | undefined;
    verbose?: boolean | undefined;
    args?: any[] | undefined;
    cli?: boolean | undefined;
    distTag?: string | undefined;
    json?: boolean | undefined;
    nodeEngineVersion?: string | undefined;
    peerDependencies?: import("../types/IndexType").Index<any> | undefined;
    rcConfigPath?: string | undefined;
};
export default mergeOptions;
